import 'package:flutter/material.dart';
import 'package:hub/backend/api_requests/api_manager.dart';
import 'package:hub/components/templates_components/details_component/details_component_widget.dart';
import 'package:hub/flutter_flow/flutter_flow_model.dart';
import 'package:hub/flutter_flow/flutter_flow_theme.dart';
import 'package:hub/flutter_flow/internationalization.dart';
import 'package:hub/pages/vehicles_on_the_property/vehicles_on_the_property.dart';
import 'package:hub/shared/utils/storage_util.dart';

class VisitsModel extends FlutterFlowModel<VehicleOnTheProperty> {
  static VisitsModel? _instance = VisitsModel._internal();
  VisitsModel._internal();
  factory VisitsModel() => _instance ?? VisitsModel._internal();
  static void resetInstance() => _instance = null;

  dynamic item;

  @override
  void initState(BuildContext context) {
    resetInstance();

    initAsync();
  }

  @override
  void dispose() {}

  Future<void> initAsync() async {}

  Widget buildVisitDetails({
    required dynamic item,
    required BuildContext context,
    required VisitsModel model,
  }) {
    return DetailsComponentWidget(
      buttons: [],
      labelsHashMap: Map<String, String>.from({
        if (item['VTA_VALIDADE'] != null && item['VTA_VALIDADE'] != '') '${FFLocalizations.of(context).getVariableText(ptText: "Validade", enText: "Validity")}:': item['VTA_VALIDADE'].toString().toUpperCase(),
        if (item['VTA_DTFIM'] != null && item['VTA_DTFIM'] != '') '${FFLocalizations.of(context).getVariableText(ptText: "Data de Fim", enText: "End Date")}:': item['VTA_DTFIM'].toString().toUpperCase(),
        if (item['VTA_DTINICIO'] != null && item['VTA_DTINICIO'] != '') '${FFLocalizations.of(context).getVariableText(ptText: "Data de Início", enText: "Start Date")}:': item['VTA_DTINICIO'].toString().toUpperCase(),
        if (item['VTA_NOME'] != null && item['VTA_NOME'] != '') '${FFLocalizations.of(context).getVariableText(ptText: "Nome", enText: "Name")}:': item['VTA_NOME'].toString().toUpperCase(),
        if (item['VTA_UNICA'] != null && item['VTA_UNICA'] != '') '${FFLocalizations.of(context).getVariableText(ptText: "Única", enText: "Unique")}:': item['VTA_UNICA'].toString().toUpperCase(),
      }),
      imagePath: 'https://freaccess.com.br/freaccess/Images/Clients/${StorageUtil().cliUUID}.png',
      statusHashMap: [
        if (item['MOT_DESCRICAO'] != null) Map<String, Color>.from({item['MOT_DESCRICAO'].toString().toUpperCase(): FlutterFlowTheme.of(context).primary}),
      ],
    );
  }
}
